/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  FSTOPPERS
 *  Copyright (C) 2008 by FUJISOFT INCORPORATED, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_sil.h,v 1.2 2008/05/26 09:04:13 myasuma Exp $
 */

/*
 *		sil.hΥץå¸NiosIIѡ
 */

#ifndef TOPPERS_PRC_SIL_H
#define TOPPERS_PRC_SIL_H

#ifndef TOPPERS_MACRO_ONLY
#include "prc_insn.h"
#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ǥȿž
 *  sil.hǤƤ뤬OMIT_SIL_ACCESSˤꤳΥե
 *  ؿƤ뤿ᡤ 
 */
#ifndef TOPPERS_SIL_REV_ENDIAN_UINT16
#define	TOPPERS_SIL_REV_ENDIAN_UINT16(data) \
				((((data) & 0xff) << 8) | (((data) >> 8) & 0xff))
#endif /* TOPPERS_SIL_REV_ENDIAN_UINT16 */

#ifndef TOPPERS_SIL_REV_ENDIAN_UINT32
#define	TOPPERS_SIL_REV_ENDIAN_UINT32(data) \
				((((data) & 0xff) << 24) | (((data) & 0xff00) << 8) \
					| (((data) >> 8) & 0xff00) | (((data) >> 24) & 0xff))
#endif /* TOPPERS_SIL_REV_ENDIAN_UINT32 */


#ifndef NIOS2
#define NIOS2   /* ץåά */
#endif 
/*
 *  ץå˰¸
 */
#ifndef TOPPERS_MACRO_ONLY


/*
 *  ٤Ƥγߤػ
 */
Inline uint32_t
TOPPERS_disint(void)
{
    uint32_t status;
    uint32_t pie_mask;
    
    /* ߤstatus쥸ͤɤ߽Ф */
    status = current_status();
    /* PIEӥåȤޥ */
    pie_mask = status & STATUS_PIE;
    /* PIEӥåȤ򥯥ꥢ߶ػߤȤ */
    status &= ~STATUS_PIE;
    /* status쥸 */
    set_status(status);

    return(pie_mask);
}


/*
 *  ߤ
 */
Inline void
TOPPERS_enaint(uint32_t TOPPERS_pie_mask)
{
    uint32_t status;

	/* ߤstatus쥸ͤɤ߽Ф */
    status = current_status();
    /* PIEӥåȤꤷߵĤȤ */
    status |= (TOPPERS_pie_mask & STATUS_PIE);
    /* status쥸 */
    set_status(status);
}


/*
 *  4.1 ߥå֤δ
 */
#define SIL_PRE_LOC   uint32_t TOPPERS_pie_mask						/* (4-1-1) */
#define SIL_LOC_INT() ((void)(TOPPERS_pie_mask = TOPPERS_disint()))	/* (4-1-2) */
#define SIL_UNL_INT() (TOPPERS_enaint(TOPPERS_pie_mask))			/* (4-1-3) */

/*
 *  4.2 Ԥ (4-2-1)
 *
 *  dlytimǻꤵ줿ʾλ֡ñ̤ϥʥáˡ롼פʤɤˤä
 *  ԤĴؿ
 *
 */
Inline void
sil_dly_nse(ulong_t dlytim)
{
	register uint32_t r4 asm("r4") = (uint32_t) dlytim;
	Asm("call _sil_dly_nse"			/* ֥ꡦƥץ졼 */
		:							/* ϥڥɡʤʤ   */
		: "r" (r4)					/* ϥڥ (r4)      */
		: "ra","r3");				/* ˲쥸 (ra, r3)    */
}

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  4.3 ץåΥǥ
 */

#define SIL_ENDIAN_LITTLE			/* (4-3-2) */

#ifndef TOPPERS_MACRO_ONLY

/*
 * 4.4 ֥ؿ
 */
#define TOPPERS_OMIT_SIL_ACCESS		/* (4-4-1) */

/*
 *  8ӥåñ̤ɽФ
 */
Inline uint8_t
sil_reb_mem(void* mem)
{
  return(__builtin_ldbuio(mem));
}

Inline void
sil_wrb_mem(void* mem, uint8_t data)
{
    __builtin_stbio(mem, data);
}


/*
 *  16ӥåñ̤ɽФ
 */
Inline uint16_t
sil_reh_mem(void* mem)
{
	return(__builtin_ldhuio(mem));
}

Inline void
sil_wrh_mem(void* mem, uint16_t data)
{
    __builtin_sthio(mem, data);
}

#define	TOPPERS_OMIT_SIL_REH_LEM		/* (4-4-2) */
#define	sil_reh_lem(mem)	sil_reh_mem(mem)

#define	TOPPERS_OMIT_SIL_WRH_LEM		/* (4-4-3) */
#define	sil_wrh_lem(mem, data)	sil_wrh_mem(mem, data)

#define	TOPPERS_OMIT_SIL_REH_BEM		/* (4-4-4) */
Inline uint16_t
sil_reh_bem(void* mem)
{
	uint16_t	data;

	data = __builtin_ldhuio(mem);
	return(TOPPERS_SIL_REV_ENDIAN_UINT16(data));
}

#define	TOPPERS_OMIT_SIL_WRH_BEM		/* (4-4-5) */
Inline void
sil_wrh_bem(void* mem, uint16_t data)
{
    __builtin_sthio(mem, TOPPERS_SIL_REV_ENDIAN_UINT16(data));
}


/*
 *  32ӥåñ̤ɽФ
 */
Inline uint32_t
sil_rew_mem(void* mem)
{
    return(__builtin_ldwio(mem));
}

Inline void
sil_wrw_mem(void* mem, uint32_t data)
{
    __builtin_stwio(mem, data);
}


#define	TOPPERS_OMIT_SIL_REW_LEM		/* (4-4-6) */
#define	sil_rew_lem(mem)	sil_rew_mem(mem)

#define	TOPPERS_OMIT_SIL_WRW_LEM		/* (4-4-7) */
#define	sil_wrw_lem(mem, data)	sil_wrw_mem(mem, data)

#define	TOPPERS_OMIT_SIL_REW_BEM		/* (4-4-8) */
Inline uint32_t
sil_rew_bem(void* mem)
{
	uint32_t	data;

	data = __builtin_ldwio(mem);
	return(TOPPERS_SIL_REV_ENDIAN_UINT32(data));
}

#define	TOPPERS_OMIT_SIL_WRW_BEM		/* (4-4-9) */
Inline void
sil_wrw_bem(void* mem, uint32_t data)
{
    __builtin_stwio(mem, TOPPERS_SIL_REV_ENDIAN_UINT32(data));
}

#endif /* TOPPERS_MACRO_ONLY */


#endif /* TOPPERS_PRC_SIL_H */
