/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  FSTOPPERS
 *  Copyright (C) 2008 by FUJISOFT INCORPORATED, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_config.h,v 1.3 2008/05/26 09:04:12 myasuma Exp $
 */

/*
 *		ץå¸⥸塼NiosIIѡ
 *
 *  Υ󥯥롼ɥեϡtarget_config.hʤޤϡ饤
 *  롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *  ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_PRC_CONFIG_H
#define TOPPERS_PRC_CONFIG_H

/*
 *  ͥ̾Υ͡
 */


/*
 *  ץåü̿Υ饤ؿ
 */
#ifndef TOPPERS_MACRO_ONLY
#include <itron.h>
#include "prc_insn.h"
#endif /* TOPPERS_MACRO_ONLY */


/*
 * ߥϥɥֹ椫顤IRCΤΥӥåȥѥޥ
 */
#define INTNO_BITPAT(intno) (1U << intno)

/*
 * ߤο
 */
#define MAX_INT_NUM 32

/*
 * 㳰θĿ
 */
#define MAX_EXC_NUM 2

/*
 *  ߥϥɥֹ˴ؤ
 */ 
#define TMIN_INHNO 0U
#define TMAX_INHNO 31U
#define TNUM_INH   32U

/*
 *  ֹ˴ؤ
 */ 
#define TMIN_INTNO 0U
#define TMAX_INTNO 31U
#define TNUM_INT   32U


#ifndef TOPPERS_MACRO_ONLY

/*
 * ߤΥͥȲΥ
 */
extern uint32_t interrupt_count;

/*
 *  6.3.2 ƥȤδ
 */
/*
 * (6-3-2-1) bool_t sense_context(void)
 *   ¹νñ̤ƥȤǼ¹ԤƤˤfalse
 *   󥿥ƥȤǼ¹ԤƤˤtrue֤ؿ
*/
Inline bool_t
sense_context()
{
    return(interrupt_count > 0);    
}

/*
 *  6.3.3 CPUå֤δ
 */
/*
 *  CPUåե饰¸Τѿ
 * 
 *  ѿϡCPUå֤λΤ߽񤭴Ƥ褤Ȥ롥
 *  饤ؿǡνѲʤ褦volatile ꡥ 
 */
extern volatile bool_t    lock_flag;   /* CPUåե饰ͤݻѿ */

#define t_lock_cpu      x_lock_cpu		/* (6-3-3-1) */
#define i_lock_cpu      x_lock_cpu		/* (6-3-3-2) */
Inline void
x_lock_cpu()							/* (6-3-3-3) */
{

    disint();			/* ϡɥ߶ػ */
    lock_flag = true;	/* CPUåե饰å */
    /* 1.6 ƥ륻νμ¸˴ؤ (c) */
    Asm("":::"memory");

}

#define t_unlock_cpu    x_unlock_cpu	/* (6-3-3-4) */
#define i_unlock_cpu    x_unlock_cpu	/* (6-3-3-5) */
Inline void
x_unlock_cpu()							/* (6-3-3-6) */
{
    /* 1.6 ƥ륻νμ¸˴ؤ (c) */
    Asm("":::"memory");
    lock_flag = false;	/* CPUåե饰å */
    enaint();
}

#define t_sense_lock    x_sense_lock	/* (6-3-3-7) */
#define i_sense_lock    x_sense_lock	/* (6-3-3-8) */
Inline bool_t
x_sense_lock()							/* (6-3-3-9) */
{
    return(lock_flag);
}


/*
 *  ߥϥɥ顿CPU㳰ϥɥ
 */

/*
 *  ߥϥɥ顦ơ֥
 */
typedef void (*nios2_fp)();
extern nios2_fp int_handler_table[MAX_INT_NUM];

/*
 *  CPU㳰ϥɥ顦ơ֥
 */
extern nios2_fp    exc_handler_table[MAX_EXC_NUM];

/*
 *
 *  ߥϥɥ
 *
 *  ͥ inhno γߥϥɥεưϤ inthdr ꤹ롥
 *  ơ֥Ͽ
 *  
 */

Inline void
x_define_inh(INHNO inhno, FP inthdr)
{
    int_handler_table[inhno] = inthdr;
}

/*
 *   CPU㳰ϥɥ
 *   ٥ơ֥Ͽ
 */   
Inline void
x_define_exc(EXCNO excno, FP exchdr)
{
    exc_handler_table[excno] = exchdr;
}


/*
 *  ߥϥɥ顿CPU㳰ϥɥν
 *  
 */


/*
 *  ߥϥɥνޥ
 */
#define INT_ENTRY(inhno, inthdr)    inthdr
#define INTHDR_ENTRY(inhno, inhno_num, inthdr) extern void inthdr(void);

/*
 *  CPU㳰ϥɥνޥ
 *
 */
#define EXC_ENTRY(excno, exchdr)    exchdr
#define EXCHDR_ENTRY(excno, excno_num, exchdr) extern void exchdr(void *p_excinf);

/*
 *  CPU㳰ȯΥƥ֤λ
 */

/*
 *  CPU㳰ȯΥƥȽ
 */
Inline bool_t
exc_sense_context(void* p_excinf)
{
    return(interrupt_count > 1); 
}

/*
 *  CPU㳰ȯ(ǥ)ͥ٥ޥλ
 */
Inline PRI
exc_get_ipm(void *p_excinf)
{
	/* p_excinfϡȯΥåɥ쥹ƬϤؤ */
	/* å¸ipmͤɤ߽Ф(76byteܤ)          */
    return((PRI)(*(((uint8_t *)(p_excinf)) + 76)));
}

/*
 *  CPU㳰ȯCPUå֤λ
 */
Inline bool_t
exc_sense_lock(void* p_excinf)
{
	/* p_excinfϡȯΥåɥ쥹Ƭ */
	/* åƬestatus쥸ͤ¸ */
    return((*(uint32_t*)p_excinf & STATUS_PIE) == 0);
}

/*
 * 6.7.6 CPU㳰ȯΥƥ֤λ
 *
 *  CPU㳰ȯΥƥ֤ˤꡢtrue/falseֵѡ
 *
 *  [trueλ]
 *   ƥȤǤ
 *   ߥå֤Ǥʤ
 *   CPUå֤Ǥʤ
 *   ʥǥΡ˳ͥ٥ޥ֤Ǥ
 *
 *  [falseλ]
 *   嵭ʳ
 *
 *  NiosIIǤϡCPU㳰ȯCPUå֤ϡstatus쥸
 *  ȽǤǤ뤿ᡤlock_flag̤˻ȤɬפϤʤ
 *
 */
Inline bool_t
exc_sense_intmask(void *p_excinf)					/* (6-7-6-1) */
{
    return(!exc_sense_context(p_excinf)
             && (exc_get_ipm(p_excinf) == 0U)
               && !exc_sense_lock(p_excinf));
}

/*
 *  CPU㳰ȯΥƥȤȳߡCPUå֤λ
 *
 *  CPU㳰ȯΥƥ֤ˤꡢtrue/falseֵѡ
 *
 *  [trueλ]
 *   ƥȤǤ
 *   ߥå֤Ǥʤ
 *   CPUå֤Ǥʤ
 *
 *  [falseλ]
 *   嵭ʳ
 *
 *  NiosIIǤϡCPU㳰ȯCPUå֤ϡstatus쥸
 *  ȽǤǤ뤿ᡤlock_flag̤˻ȤɬפϤʤ
 *
 */
Inline bool_t
exc_sense_unlock(void *p_excinf)					/* (6-7-6-2) */
{
    return(!exc_sense_context(p_excinf)
             && !exc_sense_lock(p_excinf));
}

/*
 *  6.4.1 ͥ٥ޥδ
 */

/*
 * Ƴߤγ׵ػߥե饰ξ
 */
extern uint32_t idf;

/*
 *  ͥ٥ޥ饤֥
 */

/*
 *  ߤγͥ٥ޥ
 */
extern PRI ipm;

/*
 *  ͥ٥ޥ˥åȤ롤׵ػߥե饰
 *  Υơ֥
 */
#define IPM_MASK_TBL_MAX	(MAX_INT_NUM + 1)
extern uint32_t ipm_mask_tbl[IPM_MASK_TBL_MAX];

/*
 * ͥ٥ơ֥
 */
typedef struct {
	unsigned char	num;
	unsigned char	intno[MAX_INT_NUM];
} inh_ipm_tbl_t;
extern inh_ipm_tbl_t inh_ipm_tbl[MAX_INT_NUM];

#endif /* TOPPERS_MACRO_ONLY */  

/*
 *  IPMimp_mask_tblΥǥåѴޥ
 */
#define INDEX_IPM(ipm)  (-(ipm))

#ifndef TOPPERS_MACRO_ONLY

/*
 * 6.4.1 ͥ٥ޥδ
 */
/*
 *  (ǥ)ͥ٥ޥ
 * 
 *  ꤵ줿ͥ٤ꤵ줿׵ػߥե饰Υơ֥ͤȡʥ
 *  Ρ˳Ƴߤγ׵ػߥե饰ξ֤ݻѿͤȤ
 *  ORienable쥸˥åȤꤷͥ٤ѿipm¸롥
 */
Inline void
x_set_ipm(PRI intpri)							/* (6-4-1-2) */
{
	/* ͥ٥ޥ */
    uint32_t ipm_mask = ~(ipm_mask_tbl[INDEX_IPM(intpri)]);

    /* ienable쥸
     *
     * ͥ٥ޥѤơͥ٤⤤ߤΤߵ
     * idfѤơ߶ػߤȤʤäƤʤߤΤߤ
     *
     */
    set_ienable(~(ipm_mask|idf));

	/* ͥ¸ */
    ipm = intpri;

}

#define t_set_ipm(intpri) x_set_ipm(intpri)		/* (6-4-1-3) */
#define i_set_ipm(intpri) x_set_ipm(intpri)		/* (6-4-1-4) */

/*
 *  ͥ٥ޥͤ򻲾Ȥ֤ؿ
 *
 *  ipm֤ͤ
 */
Inline PRI
x_get_ipm(void)						/* (6-4-1-5) */
{
    return(ipm);
}

#define t_get_ipm() x_get_ipm()		/* (6-4-1-6) */
#define i_get_ipm() x_get_ipm()		/* (6-4-1-7) */


/*
 * 6.4.2 ׵ػߥե饰δ
 */
/*
 *  °ꤵƤ뤫Ƚ̤뤿ѿ
 */
extern uint32_t	bitpat_cfgint;

/*
 * ʥǥΡ˳׵ػߥե饰Υå
 *
 *  ꤵ줿ֹγ׵ػߥե饰ΥåȤơߤ
 *  ػߤ롥ޤʥǥΡ˳׵ػߥե饰idf
 *  ӥåȤ򥻥åȤ롥
 *  ׵ޥ뵡ǽ򥵥ݡȤƤʤˤϡfalse֤
 */
Inline bool_t
x_disable_int(INTNO intno)								/* (6-4-2-2) */
{
	/* Ϥ줿ֹϿƤ뤫Υå */
    if ((bitpat_cfgint & INTNO_BITPAT(intno)) == 0U) {
        return(false);
    }
    
	/* ꤵ줿ֹ߶ػߤ */
	disirq(intno);
	
    /* ߶ػ߾ݻե饰ι */
    idf |= INTNO_BITPAT(intno);

    return(true);
}

#define t_disable_int(intno)  x_disable_int(intno)		/* (6-4-2-3) */
#define i_disable_int(intno)  t_disable_int(intno)		/* (6-4-2-4) */

/* 
 * (ǥ)׵ػߥե饰β
 *
 * ꤵ줿ֹγ׵ػߥե饰Υꥢơߤ
 * Ĥ롥ޤʥǥΡ˳׵ػߥե饰idf
 * ӥåȤ򥯥ꥢ롥
 * ׵ޥ뵡ǽ򥵥ݡȤƤʤˤϡfalse֤
 */
Inline bool_t
x_enable_int(INTNO intno)							/* (6-4-2-5) */
{
	/* Ϥ줿ֹϿƤ뤫Υå */
    if ((bitpat_cfgint & INTNO_BITPAT(intno)) == 0U) {
        return(false);
    }    

	/* ꤵ줿ֹߵĤ */
	enairq(intno);
	
    /* ߶ػ߾ݻե饰ι */
    idf &= ~INTNO_BITPAT(intno);

    return(true);
}

#define t_enable_int(intno) x_enable_int(intno)		/* (6-4-2-6) */
#define i_enable_int(intno) x_enable_int(intno)		/* (6-4-2-7) */

/*
 * 6.4.3 ׵Υꥢ
 *
 * intnoǻꤵ줿׵饤󤬥åȥꥬǤˡ
 * ȥꥬ줿׵򥯥ꥢؿ
 * 
 * NiosIIǤǤϳߥȥФơå饤Ȥä
 * ߥȥꥬϤƤʤᡢδؿΤߤѰա
 * ޤܴؿϥå¸Ѥʤ͡
 * 
 */
Inline void
x_clear_int(INTNO intno)							/* (6-4-3-1) */
{

}

#define t_clear_int(intno) x_clear_int(intno)		/* (6-4-3-2) */
#define i_clear_int(intno) x_clear_int(intno)		/* (6-4-3-3) */

/*
 *  6.4.4 ׵Υץ
 *
 *  intnoǻꤵ줿׵饤Фơߤ
 *  ׵ᤵƤtrueǤʤfalse֤ؿ
 *
 *  ipending쥸򻲾Ȥ뤳ȤȽǤ롥
 */
Inline bool_t
x_probe_int(INTNO intno)							/* (6-4-4-1) */
{
	/* ǻꤵ줿ֹ椬ڥǥ椫ֵ */
	return ((current_ipending() & (1 << intno)) > 0);
}

#define t_probe_int(intno) x_probe_int(intno)		/* (6-4-4-2) */
#define i_probe_int(intno) x_probe_int(intno)		/* (6-4-4-3) */


/*
 * 6.4.6 ׵饤°
 */
extern void	x_config_int(INTNO intno, ATR intatr, PRI intpri);	/* (6-4-6-2) */

/*
 *  6.4.5 ߥϥɥƬ
 *
 *  NiosIIǤϸ뤳Ȥ̵
 */
Inline void
i_begin_int(INTNO intno)							/* (6-4-5-1) */
{
    
}

Inline void
i_end_int(INTNO intno)								/* (6-4-5-2) */
{
    
}


/*
 *  TCB Ϣ
 */
/*
 *  6.5.1 ƥȥ֥åΥǡ
 */
typedef struct task_context_block {
        void*  sp;          /* åݥ */
        FP  pc;             /* ץ५ */
} CTXB;						/* (6-5-1-1) */

/*
 *  6.5.3 ƥȤΥǥѥå
 */

/*
 *  ǹ̥ͥؤΥǥѥåcpu_support.S
 *
 *  dispatch ϡƥȤƤӽФ줿ӥ
 *  ǡCPUå֤ǸƤӽФʤФʤʤ
 */
extern void    dispatch(void);					/* (6-5-3-1) */

/*
 *  calltexϻѤʤ
 */
#define OMIT_CALLTEX							/* (6-5-3-2) */


/*
 *  ǹ̥ͥؤΥǥѥåprc_support.S
 *
 *  dispatchϡƥȤƤӽФ줿ӥ
 *  ƤӽФ٤ΤǡƥȡCPUå֡ǥѥ
 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
 *  Фʤʤ
 */
extern void	dispatch(void);

/*
 *  6.5.4 ǥѥåưϡprc_support.S
 *
 *  start_dispatchϡͥ뵯ư˸ƤӽФ٤Τǡ٤Ƥγ
 *  ߤػߤ֡ߥå֤Ʊξ֡ˤǸƤӽФʤ
 *  ʤʤ
 */
extern void	start_dispatch(void) NoReturn;		/* (6-5-4-1) */

/*
 *  6.5.5 ߤΥƥȤΤƤƥǥѥåprc_support.S
 *
 *  exit_and_dispatchϡext_tskƤӽФ٤Τǡƥ
 *  ȡCPUå֡ǥѥåľ֡ʥǥΡ˳ͥ
 *  ٥ޥ֤ǸƤӽФʤФʤʤ
 */
extern void	exit_and_dispatch(void) NoReturn;	/* (6-5-5-1) */

/*
 *  6.5.6 εưprc_support.S
 *
 * εưactivate_contextˤϡٻ߾֤¹ԤǤ
 * ֤ˤ˸ƤФ졤ꤵ줿TCBΥåݥ󥿤
 * ¹ԺƳϤ򥿥ϻstart_rˤꤹ롥λǤϡ
 * ꤵ줿ΥåΰȤäƤϤʤʤ
 *
 *  activate_context򡤥饤ؿǤϤʤޥȤƤΤϡ
 *  λǤTCBƤʤǤ롥
 */
extern void	start_r(void);

#define activate_context(p_tcb)											\
{																		\
	(p_tcb)->tskctxb.sp = (void *)((char *)((p_tcb)->p_tinib->stk)		\
										+ (p_tcb)->p_tinib->stksz);		\
	(p_tcb)->tskctxb.pc = (void *) start_r;								\
}

/*
 *  ͥνλθƽФprc_support.S
 *
 *  call_exit_kernelϡͥνλ˸ƤӽФ٤Τǡ󥿥
 *  ƥȤڤ괹ơͥνλexit_kernelˤƤӽ
 *  
 */
extern void call_exit_kernel(void) NoReturn;	/* (6-8-3) */


/*
 *  ץå¸ν
 */
extern void    prc_initialize(void);

/*
 *  ץå¸νλ
 */
extern void    prc_terminate(void);


/*
 * ̤Ͽγ/㳰ȯΥ
 */
extern void     no_reg_interrupt(void);
extern void     no_reg_exception(VP p_excinf);

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  atexit νȥǥȥ饯μ¹
 */
#ifndef TOPPERS_MACRO_ONLY

Inline void
call_atexit()						/* (6-8-4) */
{
	extern void	software_term_hook(void);
	void (*volatile fp)(void) = software_term_hook;

	/*
	 *  software_term_hookؤΥݥ󥿤򡤰övolatile FPfp
	 *  ƤȤΤϡ0ȤӤŬǺʤ褦
	 *  ˤ뤿Ǥ롥
	 */
	if (fp != 0) {
		(*fp)();
	}
}

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_PRC_CONFIG_H */
