/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  FSTOPPERS
 *  Copyright (C) 2008 by FUJISOFT INCORPORATED, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_syssvc.h,v 1.2 2008/05/26 09:06:21 myasuma Exp $
 */

/*
 *  ƥॵӥΥåȰ¸FSMPB for NiosIIѡ
 *
 *  ƥॵӥΥåȰ¸Υ󥯥롼ɥե롥Υե
 *  Ƥϡݡͥȵҥե˵Ҥ졤Υե
 *  ̵ʤ븫ߡ
 */

#ifndef TOPPERS_TARGET_SYSSVC_H
#define TOPPERS_TARGET_SYSSVC_H

/*
 *  åȥƥΥϡɥ񸻤
 */
#include "fsmpb.h"

/*
 *  ȥ졼˴ؤ
 */
#include "logtrace/trace_config.h"


/*
 * 8.1 ƥǽΥåȰ¸
 */
/* ưåΥå̾ */
#define    TARGET_NAME    "FSMPB for NiosII"				/* (8-1-1) */

/* åȰ¸ */								/* (8-1-2) */
#define		TARGET_COPYRIGHT	"Copyright (C) Since 2008 by FUJI SOFT INCORPORATED."

/* ƥǽΥХåեΥ */
/* #define		TCNT_SYSLOG_BUFFER	64					  *//* (8-1-3) */

/*
 *  åȥƥʸ
 *
 *  ƥ٥ʸϥ롼ROM˥ƽФǼ¸뤳
 *  ȤꤷƤ롥
 */
extern void target_fput_log(char_t c);						/* (8-1-4) */


/*
 * 8.2 ΥåȰ¸
 */
/* ͥ (default:3)*/
/* #define		LOGTASK_PRIORITY	3					  *//* (8-2-1) */

/* Υå (default:1024) */
/* #define		LOGTASK_STACK_SIZE	1024				  *//* (8-2-2) */

/* νΥꥢݡֹ (default:1) */
/* #define		LOGTASK_PORTID		1					  *//* (8-2-3) */

/* ưֳ (default:10ms) */
/* #define		LOGTASK_INTERVAL	10					  *//* (8-2-4) */

/* ϤԤ碌ˤơԤñ̤Ȥʤ */
/* (default:1)                                                        */
/* #define		LOGTASK_FLUSH_WAIT	1					  *//* (8-2-5) */

#endif /* TOPPERS_TARGET_SYSSVC_H */
